<xsl:stylesheet version = '1.0' 
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<xsl:output method = "xml" indent="yes" encoding="iso-8859-1" media-type="image/svg-xml"/>

<xsl:variable name="totalBullets"> 
     <xsl:value-of select="count(//li)"/> 
</xsl:variable> 

<xsl:template match="/">

<xsl:processing-instruction name="xml-stylesheet">
<xsl:text>href="css/presentation.css" type="text/css"</xsl:text>
</xsl:processing-instruction>

<svg width="600" height="400">

<!-- defs here -->

	<xsl:apply-templates/>
	</svg>
</xsl:template>
	
<xsl:template match="//h1"> 
	<g transform="translate(100,40)">
	<text class="heading" x="0" y="30" >
          <xsl:value-of select="."/>  
    </text>
    </g> 
</xsl:template>

<xsl:template match="//li"> 
 
<xsl:variable name="bulletNumber"><xsl:number/></xsl:variable> 
<xsl:variable name="y">
  <xsl:value-of select="number(60) + number(250) * number($bulletNumber) div number($totalBullets)"/> 
</xsl:variable> 
	

<xsl:element name="g">
	<xsl:attribute name="transform">translate(150, <xsl:value-of select="$y"/>)</xsl:attribute> 

	<circle class="bullet" r="10" />
	<text class="bullet">	
          <xsl:value-of select="."/>
    </text>
</xsl:element>
</xsl:template>

<xsl:template match="/html/head/title"> 
          <xsl:copy-of select="."/>
          <desc>Some benefits of SVG+XSLT</desc>
</xsl:template>

</xsl:stylesheet>

