<xsl:stylesheet version = '1.0' 
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<xsl:output method = "xml" indent="yes" encoding="iso-8859-1" media-type="image/svg-xml"/>

<xsl:variable name="totalBullets"> 
     <xsl:value-of select="count(//li)"/> 
</xsl:variable> 

<xsl:template match="/">

	<svg width="600" height="400">
	
	<defs>
	
	<style type="text/css"><![CDATA[
	text.heading{filter:url(#3D); font-size:36; font-weight:bold; fill:brown}

.bullet {filter:url(#dropShadow)}
circle.bullet {fill:lightblue }
text.bullet {font-size:18; font-weight:bold; text-anchor:left; fill:orange}
    ]]></style>
    
<filter id="dropShadow">
  <feGaussianBlur in="SourceAlpha" stdDeviation=".8" result="blur"/>
  <feOffset in="blur" dx="1" dy="1" result="offsetBlurredAlpha"/>
  <feMerge>
    <feMergeNode in="offsetBlurredAlpha"/>
    <feMergeNode in="SourceGraphic"/>
  </feMerge>
</filter>

<filter id="3D" filterUnits="userSpaceOnUse" x="0" y="0" width="400" height="150">
  <feGaussianBlur in="SourceAlpha" stdDeviation="1" result="blur"/>
   <feSpecularLighting in="blur" surfaceScale="3" specularConstant=".5" 
                      specularExponent="3" lighting-color="#ffffff" 
                      result="specOut">
    <fePointLight x="-5000" y="-5000" z="500"/>
  </feSpecularLighting>
 <feOffset in="blur" dx="1" dy="1" result="offsetBlur"/>
  <feComposite in="specOut" in2="SourceAlpha" operator="in" result="specOut"/>
  <feComposite in="SourceGraphic" in2="specOut" operator="arithmetic" 
               k1="0" k2="1" k3="1" k4="0" result="litPaint"/>
  <feMerge>
    <feMergeNode in="offsetBlur"/>
    <feMergeNode in="litPaint"/>
  </feMerge>
</filter>
</defs>


	<xsl:apply-templates/>
	</svg>
</xsl:template>
	
<xsl:template match="//h1"> 
	<g transform="translate(100,40)">
	<text class="heading" x="0" y="30" >
          <xsl:value-of select="."/>  
    </text>
    </g> 
</xsl:template>

<xsl:template match="//li"> 
 
<xsl:variable name="bulletNumber"><xsl:number/></xsl:variable> 
<xsl:variable name="y">
  <xsl:value-of select="number(60) + number(250) * number($bulletNumber) div number($totalBullets)"/> 
</xsl:variable> 
	

<xsl:element name="g">
	<xsl:attribute name="transform">translate(150, <xsl:value-of select="$y"/>)</xsl:attribute> 

	<circle class="bullet" r="10" />
	<text class="bullet">	
          <xsl:value-of select="."/>
    </text>
</xsl:element>
</xsl:template>

<xsl:template match="/html/head/title"> 
          <xsl:copy-of select="."/>
          <desc>A slide converted from HTML</desc>
</xsl:template>

</xsl:stylesheet>

