<%@ Page Language="c#" %>
<%@ Import Namespace="System.IO" %>
<script runat="server">
void Page_Load() {
  Response.ContentType = "image/svg+xml";
  string[] colors = {"aqua", 
                     "blue",
                     "fuchsia",
                     "gray",
                     "green",
                     "lime",
                     "maroon",
                     "navy",
                     "olive",
                     "purple",
                     "red",
                     "silver",
                     "teal",
                     "yellow"};
  string bars = "";
  string pname = Request.QueryString["pname"];
  int cntbars = Convert.ToInt32(Request.QueryString["cntbars"]);
  int sum = Convert.ToInt32(Request.QueryString["sum"]);
  double factor = 170*85/(Convert.ToInt32(Request.QueryString["maxvote"]));
  for (int i=1; i<=cntbars; i++) {
    bars += "<rect width=\"0\" height=\"30\" x=\"20\" y=\"" + (5 + 45*i) + "\" style=\"fill:";
    bars += colors[(i-1) % colors.Length];
    bars += ";stroke:black\" id=\"row" + i + "\">\n";
    bars += "<animate attributeName=\"width\" from=\"0\" to=\"33\" begin=\"1s\" dur=\"2s\" repeatCount=\"1\" fill=\"freeze\" />\n";
    bars += "<animate attributeName=\"width\" from=\"33\" to=\""; 
    bars += Convert.ToInt32(factor*Convert.ToInt32(Request.QueryString["votes" + i])/sum);
    bars += "\" begin=\"3s\" dur=\"4s\" repeatCount=\"1\" fill=\"freeze\" /></rect>\n";
    bars += "<text x=\"40\" y=\"" + (25 + 45*i) + "\" id=\"text" + i + "\" style=\"font-face:Arial, Geneva, Helvetica, sans-serif; font-size:9pt;color:black;visibility:hidden\" >";
    bars += Server.HtmlEncode(Request.QueryString["name" + i]);
    bars += " (" + Convert.ToInt32(100*Convert.ToInt32(Request.QueryString["votes" + i])/sum) + "%)";
    bars += "<set attributeType=\"CSS\" attributeName=\"visibility\" to=\"visible\" begin=\"6s\" dur=\"1s\" repeatCount=\"1\" fill=\"freeze\" /></text>";
  }
  StreamReader sr = new StreamReader(Server.MapPath("torso2.svg"));
  string svg = sr.ReadToEnd();
  sr.Close();

  svg = svg.Replace("%BARS%", bars);
  svg = svg.Replace("%SVGHEIGHT%", (115 + 45*cntbars).ToString());
  svg = svg.Replace("%POLLNAME%", pname);
  svg = svg.Replace("%AXISY%", (65 + 45*cntbars).ToString());
  svg = svg.Replace("%AXISY-%", (60 + 45*cntbars).ToString());
  svg = svg.Replace("%AXISY+%", (70 + 45*cntbars).ToString());
  svg = svg.Replace("%AXISTEXTY%", (85 + 45*cntbars).ToString());
  Response.Write(svg);
} 
</script>