

/**
 * Title:        PanelQuery
 * Description:  servlet to query panel data from  MySql datasource
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author
 * @version 1.0
 */


import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class PanelQuery extends HttpServlet {
  //Note: set this to the file path for your server
  private static final String SERVLET_PATH = "http://www.yourserver.com/servlet/";

  private static final String CONTENT_TYPE = "text/html";
  private Connection con = null;

  /**Initialize global variables*/
  public void init(ServletConfig config) throws ServletException {
    super.init(config);

    try {
      // Load (and therefore register) the MYSQL MM driver
      Class.forName("org.gjt.mm.mysql.Driver").newInstance();

      // this must be edited to reflect your database, user name, and password
      con = DriverManager.getConnection("jdbc:mysql://localhost/database?autoReconnect=true", "user", "password");
    }
    catch (ClassNotFoundException e) {
      throw new UnavailableException("Couldn't load database driver");
    }
    catch (SQLException e) {
      throw new UnavailableException("Couldn't get db connection");
    }
    catch (IllegalAccessException e) {
      throw new UnavailableException("Illegal access");
    }
    catch (Exception e) {
      throw new UnavailableException("General Acess error");
    }
  }

  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response)
   throws ServletException, IOException {
   //initialize variables
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();

    String line = "";
    String mkno = "";
    String cmd = "";
    StringBuffer sql;
    String [] values = new String[35];
    HashMap columns = new HashMap();
    ResultSet rs;
    ResultSetMetaData rsmd;

    Enumeration enum  = request.getParameterNames();
    while (enum.hasMoreElements()) {
      String name = (String)enum.nextElement();
      if (name.toLowerCase().equals("mkno")) {
        values = request.getParameterValues(name);
        mkno = values[0];
        columns.put(name,values[0]);
      }
      else if (name.equals("cmd")) {
        values = request.getParameterValues(name);
        cmd = values[0];
      }
      else {
        values = request.getParameterValues(name);
        columns.put(name,values[0]);
      }
    }
    out.println("<HTML>");
    out.println("<HEAD>");
    out.println("	<TITLE>AEC Panel Query</TITLE>");
    out.println("</HEAD>");
    out.println(" <BODY>");
    if (mkno.charAt(0)=='V') out.println("<H3>Vision lite</H3>");
    else out.println("<H3>Alucobond Panel</H3>");

     try {
      Statement stmt = con.createStatement();
      if (cmd.equals("query")) {
        sql = new StringBuffer(
           "SELECT * FROM aec_panels WHERE MkNo=\"" + mkno + "\"" );
        if (stmt.execute(sql.toString())) {
          rs = stmt.getResultSet();
          rsmd = rs.getMetaData();
          out.println("<FORM ACTION=\""+SERVLET_PATH+"PanelQuery? METHOD=\"POST\" ENCTYPE=\"application/x-www-form-urlencoded\">");
          out.println("<TABLE>");
          while (rs.next()) {
            for (int i = 1; i <= rsmd.getColumnCount(); i++) {
              out.println("<tr><TD WIDTH=\"26%\">" +
                          rsmd.getColumnName(i).toUpperCase() + "</td>");
              out.print("<TD WIDTH=\"74%\"> <INPUT TYPE=\"TEXT\" NAME=\"" +
                          rsmd.getColumnName(i) +"\" SIZE=\"35\" VALUE=\"");
                  if (rsmd.getColumnType(i)== Types.INTEGER)
                                              out.print(rs.getInt(i));
                  else if (rsmd.getColumnType(i)== Types.VARCHAR)
                                              out.print(rs.getString(i));
                  else if (rsmd.getColumnType(i)== Types.CHAR)
                                              out.print(rs.getString(i));
                  else if (rsmd.getColumnType(i)== Types.DATE)
                                              out.print(rs.getDate(i));
                  else if (rsmd.getColumnType(i)== Types.FLOAT)
                                              out.print(rs.getFloat(i));
                  out.println("\"></td></tr>");
             }
          }
          out.println("</TABLE>");
          out.println("<INPUT TYPE='SUBMIT' VALUE='update' NAME='cmd'>");
          out.println(" </FORM>");
        }

      }
      else if (cmd.equals("update")) {
        sql =  new StringBuffer("UPDATE aec_panels SET " );
        //out.println("sql: " + sql.toString());
        int f = 0;
        Object[] fields = columns.keySet().toArray();
        for (int i = 0; i<fields.length;i++) {
          if ((!columns.get(fields[i]).equals("")) && (!fields[i].equals("MkNo"))) {
            if (f > 0) sql.append(",");
            f++;
            sql.append(fields[i]+"='"+columns.get(fields[i])+"'");
          }
        }
        sql.append(" WHERE MkNo='"+mkno+"';");
        out.println("sql: " + sql.toString());
        stmt.executeUpdate(sql.toString());
        out.println("<H3>Update successful</H3>");
      }
      out.println(" </BODY>");
      out.println("</HTML>");
      stmt.close();
    } catch (SQLException e) {
      out.println("<pre>ERROR:Mysql: " + e.getMessage());
      out.println(e.getSQLState());
      if (e.getSQLState().equals("08S01")) {
        out.println("Connection lost");
      }
      out.println("</pre>");
    } catch (Exception e) {
      throw new UnavailableException("General Acess error");
    }
 }

  /**Process the HTTP Post request*/
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request,response);
  }

  /**Clean up resources*/
  public void destroy() {
    // Clean up.
    try {
      if (con != null) con.close();
    }
    catch (SQLException ignored) { };
  }
}