

/**
 * Title:        dataQuery2
 * Description:  DataQuery MySQL with SVG Chart
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author rkg
 * @version 1.0
 */

  import java.io.*;
  import java.util.*;
  import java.sql.*;

public class SvgChart2 {
  private Connection con = null;
  private String table;
  private String id;


  public SvgChart2(Connection con, String table, String id) {
    this.con = con;
    this.table = table;
    this.id = id;
  }

  public void write(PrintWriter out) {
    String sql = "";
    int total;
    String line;
    StringBuffer buf;

    if ((table!=null) && (id!=null)) {
      try {
        Statement stmt = con.createStatement();
        sql = "SELECT * FROM " + table + " WHERE id=\"" + id + "\";";

        if (stmt.execute(sql)) {
          // There is a ResultSet
           ResultSet rs = stmt.getResultSet();

          // There is only one record
          if (rs.next()) {
            total = rs.getInt("total");
            BufferedReader infile = new BufferedReader(new FileReader( "C:/Program Files/Apache Group/jakarta-tomcat/webapps/DataQuery2/svg/chart.svg"));

            while (((line = infile.readLine()) != null)) {
              if (line.startsWith("<text id=\"title\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf(">")+1));
                buf = buf.append(table + " tract: " + id);
                line = buf.append(line.substring(line.indexOf("</"))).toString();
              }
              else if (line.startsWith("<text id=\"totalTxt\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf(">")+1));
                buf = buf.append("Total: " + total);
                line = buf.append(line.substring(line.indexOf("</"))).toString();
              }
              else if (line.startsWith("<text id=\"totalMaleTxt\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf(">")+1));
                buf = buf.append(Integer.toString(rs.getInt("totalMale")));
                line = buf.append(line.substring(line.indexOf("</"))).toString();
              }
              else if (line.startsWith("<text id=\"totalFemaleTxt\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf(">")+1));
                buf = buf.append(Integer.toString(rs.getInt("totalFemale")));
                line = buf.append(line.substring(line.indexOf("</"))).toString();
              }

              if (line.startsWith("<rect id=\"under18\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("under18")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"adult\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("adult")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"over65\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("over65")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }

              if (line.startsWith("<rect id=\"under18Male\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("under18Male")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"adultMale\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("adultMale")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"over65Male\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("over65Male")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }

              if (line.startsWith("<rect id=\"under18Female\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("under18Female")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"adultFemale\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("adultFemale")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              else if (line.startsWith("<rect id=\"over65Female\"")) {
                buf = new StringBuffer(line.substring(0,line.indexOf("height=")+8));
                buf = buf.append(Double.toString(rs.getInt("over65Female")*100.0/total));
                line = buf.append(line.substring(line.indexOf("\" style="))).toString();
              }
              out.println(line);
            } //while
            infile.close();
          }
          rs.close();
        } else {
          out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">"+table + " has no record for Id =" + id+"</text></svg>");
        }
        stmt.close();
      } catch (SQLException e) {
        out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">ERROR:Mysql  " + e.getMessage()+"</text></svg>");
      } catch (IOException e) {
       out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">IO ERROR:Infile  " + e.getMessage()+"</text></svg>");
      }
    } else {
        out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">Error: table or id parameter is null</text></svg>");
    }

  }
}