

/**
 * Title:        dataQuery
 * Description:  servlet to query data from  MySql datasource using Jaxp
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author Randy George
 * @version 1.0
 */

  import java.io.*;
  import org.xml.sax.*;
  import org.xml.sax.helpers.DefaultHandler;
  import java.sql.*;

public class SVGContentHandler extends DefaultHandler {
  private PrintWriter out;
  private Connection con = null;
  private String table;
  private String id;

  private ResultSet rs;
  private boolean results;
  private boolean skipTxt = false;
  private int total;

  public SVGContentHandler(PrintWriter out, Connection con, String table, String id) {
    this.out = out;
    this.con = con;
    this.table = table;
    this.id = id;

    String sql = "";

      // Collect query results
      try {
        Statement stmt = con.createStatement();
        sql = "SELECT * FROM " + table + " WHERE id=\"" + id + "\";";
        //out.println(sql);
        if (stmt.execute(sql)) {
          // There is a ResultSet
          rs = stmt.getResultSet();

          if (rs.next()) {
            results = true;
            total = rs.getInt("total");
          }
          stmt.close();
        }
      } catch (SQLException e) {
        out.println("MySQL Error: " + e.getMessage());
      }
  }

  public void processingInstruction(String target, String data) throws SAXException {
    out.println(target+data);
  }

  public void startElement(String namespaceURI, String localName, String rawName, Attributes atts) throws SAXException {
      try {
        out.print("<"+localName);
        for (int i=0; i<atts.getLength(); i++) {
          if (results && (localName.equals("rect") && atts.getLocalName(i).equals("height"))) {
            out.print(" "+atts.getLocalName(i)+"=\""+(rs.getInt(atts.getValue("id"))*100.0/total)+"\"");
          }
          else out.print(" "+atts.getLocalName(i)+"=\""+atts.getValue(i)+"\"");
        }
        out.print(">");
        if (results) {
          if (localName.equals("text") &&
                  atts.getValue("id")!=null &&
                    atts.getValue("id").equals("title")){
            out.print(table + " - Tract: " + id);
            skipTxt = true;
          }
          else if (localName.equals("text") &&
                  atts.getValue("id")!=null &&
                    atts.getValue("id").equals("totalTxt")){
            out.print("Total: " + rs.getInt("total"));
            skipTxt = true;
          }
          else if (localName.equals("text") &&
                  atts.getValue("id")!=null &&
                    atts.getValue("id").equals("totalMaleTxt")){
            out.print(rs.getInt("totalMale"));
            skipTxt = true;
          }
          else if (localName.equals("text") &&
                  atts.getValue("id")!=null &&
                    atts.getValue("id").equals("totalFemaleTxt")){
            out.print(rs.getInt("totalFemale"));
            skipTxt = true;
          }
      }
    } catch (SQLException e) {
      out.print("Sql error");
    }
  }

  public void endElement(String namespaceURI, String localName, String rawName) throws SAXException {
    out.print("</"+localName+">");
    skipTxt = false;
  }

  public void characters(char[] characters, int start, int end) throws SAXException {
    if (!skipTxt) {
      String line = new String(characters,start,end);
      out.print(line);
    }
  }

  public void ignorableWhitespace(char[] characters, int start, int end) throws SAXException {
    String line = new String(characters,start,end);
    out.print(line);
  }

  public void endDocument() throws SAXException {
    try {
      rs.close();
    } catch (SQLException e) {
        out.println("MySQL Error: " + e.getMessage());
    }
  }
}