

/**
 * Title:        dataQuery
 * Description:  servlet to query data from  MySql datasource using DOMParser
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author
 * @version 1.0
 */

  import java.io.*;
  import java.util.*;
  import java.sql.*;
  import javax.xml.parsers.DocumentBuilder;
  import javax.xml.parsers.DocumentBuilderFactory;
  import javax.xml.parsers.ParserConfigurationException;
  import org.xml.sax.SAXException;
  import org.apache.xml.serialize.XMLSerializer;
  import org.apache.xml.serialize.OutputFormat;
  import org.w3c.dom.*;

public class SvgChart4 {
  private Connection con = null;
  private String table;
  private String id;


  public SvgChart4(Connection con, String table, String id) {
    this.con = con;
    this.table = table;
    this.id = id;
  }

  public void write(PrintWriter out) {
    String sql = "";
    int total;

    if ((table!=null) && (id!=null)) {
      String template = "C:/Program Files/Apache Group/jakarta-tomcat/webapps/DataQuery4/svg/chart.svg";
      // setup DOM Parser with result set
      try {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder svgParser = factory.newDocumentBuilder();
        // read in our template and parse into a DOM tree
        Document doc = svgParser.parse( new File(template));
        try {
          //collect a result set from our sql query
          Statement stmt = con.createStatement();
          sql = "SELECT * FROM " + table + " WHERE id=\"" + id + "\"";
          if (stmt.execute(sql)) {
            // There is a ResultSet
            ResultSet rs = stmt.getResultSet();
            // There is only one record
            while (rs.next()) {
              total = rs.getInt("total");

              // use org.w3c.dom methods to change the dom tree according to the result record
              Element obj;
              obj = doc.getElementById("title");
              obj.getFirstChild().setNodeValue(table + " - tract: " + id);

              obj = doc.getElementById("totalTxt");
              obj.getFirstChild().setNodeValue("Total: " + total);
              obj = doc.getElementById("totalMaleTxt");
              obj.getFirstChild().setNodeValue("Total: " + rs.getInt("totalMale"));
              obj = doc.getElementById("totalFemaleTxt");
              obj.getFirstChild().setNodeValue("Total: " + rs.getInt("totalFemale"));

              obj = doc.getElementById("under18");
              obj.setAttribute("height", Double.toString(rs.getInt("under18")*100.0/total));
              obj = doc.getElementById("adult");
              obj.setAttribute("height", Double.toString(rs.getInt("adult")*100.0/total));
              obj = doc.getElementById("over65");
              obj.setAttribute("height", Double.toString(rs.getInt("over65")*100.0/total));

              obj = doc.getElementById("under18Male");
              obj.setAttribute("height", Double.toString(rs.getInt("under18Male")*100.0/total));
              obj = doc.getElementById("adultMale");
              obj.setAttribute("height", Double.toString(rs.getInt("adultMale")*100.0/total));
              obj = doc.getElementById("over65Male");
              obj.setAttribute("height", Double.toString(rs.getInt("over65Male")*100.0/total));

              obj = doc.getElementById("under18Female");
              obj.setAttribute("height", Double.toString(rs.getInt("under18Female")*100.0/total));
              obj = doc.getElementById("adultFemale");
              obj.setAttribute("height", Double.toString(rs.getInt("adultFemale")*100.0/total));
              obj = doc.getElementById("over65Female");
              obj.setAttribute("height", Double.toString(rs.getInt("over65Female")*100.0/total));

            }
            rs.close();
          } else {
            out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">"+table + " has no record for Id =" + id+"</text>");
          }
          stmt.close();
        } catch (SQLException e) {
          out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">ERROR:Mysql  " + e.getMessage()+"</text>");
        }

        // now that the changes are done output the doc to our servlet response
        XMLSerializer serializer = new XMLSerializer((Writer)out, new OutputFormat(doc,"UTF-8",true));
        serializer.serialize(doc);
      } catch (IOException e) {
        out.println("IO Error: " + e.getMessage());
        e.printStackTrace(out);
      } catch (ParserConfigurationException e) {
        out.println("Parser Configuration Error: " + e.getMessage());
      } catch (SAXException e) {
        out.println("SAX Excepion: " + e.getMessage());
      }
    }
  }
}