

/**
 * Title:        dataQuery
 * Description:  servlet to query data from  MySql datasource using DOMParser
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author Randy George
 * @version 1.0
 */

  import javax.servlet.*;
  import javax.servlet.http.*;
  import java.io.*;
  import java.util.*;
  import java.sql.*;


public class dataQuery4 extends HttpServlet {
  private Connection con = null;
  //Note: set this to the file path for your server
  public static final String FILE_PATH = "/home/httpd/html/svgtest/svg/";

  /**Initialize global variables*/
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    try {
      // Load (and therefore register) the MYSQL MM driver
      Class.forName("org.gjt.mm.mysql.Driver").newInstance();
      //establish connection to  database
      // Note: this will need to be edited to your system database name, user, and password
      con = DriverManager.getConnection("jdbc:mysql://localhost/sams", "user", "password");
    }
    catch (ClassNotFoundException e) {
      throw new UnavailableException("Couldn't load database driver");
    }
    catch (SQLException e) {
      throw new UnavailableException("Couldn't get db connection");
    }
    catch (IllegalAccessException e) {
      throw new UnavailableException("Illegal access");
    }
    catch (Exception e) {
      throw new UnavailableException("General Acess error");
    }
  }

  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

    //initialize variables
    String table = "";
    String id = "";
    boolean chart = false;
    String sql = "";
    String [] values = new String[10];
    int total;

    //collect parameters
    Enumeration enum  = request.getParameterNames();
    while (enum.hasMoreElements()) {
      String name = (String) enum.nextElement();
      if (name.equals("table")) {
        values = request.getParameterValues(name);
        table = values[0];
      }
      else if (name.equals("id")){
        values = request.getParameterValues(name);
        id =  values[0];
      }
      else if (name.equals("chart")){
        values = request.getParameterValues(name);
        chart =  values[0].equals("true");
      }
    }

    if ((table!="") && (id!="")) {
      if (chart) {
        response.setContentType("image/svg+xml");
        SvgChart4 outChart = new SvgChart4(con,table,id);
        outChart.write(response.getWriter());
      } else {
        response.setContentType("text/html");
        HtmlTable4 outTable = new HtmlTable4(con,table,id);
        outTable.write(response.getWriter());
      }
    }
 }


  /**Process the HTTP Post request*/
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request,response);
  }

  /**Clean up resources*/
  public void destroy() {
    // Clean up.
    try {
      if (con != null) con.close();
    }
    catch (SQLException ignored) { };
  }
}