

/**
 * Title:        dataQuery5
 * Description:  servlet to query data from  MySql datasource using JDOM
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author Randy George
 * @version 1.0
 */

  import java.io.*;
  import java.util.*;
  import java.sql.*;

public class HtmlTable5 {
  private Connection con = null;
  private String table;
  private String id;


  public HtmlTable5(Connection con, String table, String id) {
    this.con = con;
    this.table = table;
    this.id = id;
  }

  public void write(PrintWriter out) {
    String sql = "";

    out.println("<html>");
    out.println("<head>");
    out.println("	<title>Data Query</title>");
    out.println("</head>");
    out.println(" <body>");
    if ((table!=null) && (id!=null)) {
      out.println("<h3>Query - " + table +"</h3>");
      try {
        Statement stmt = con.createStatement();
        sql = "SELECT * FROM " + table + " WHERE id=\"" + id + "\";";
        if (stmt.execute(sql)) {
          // There is a ResultSet
          ResultSet rs = stmt.getResultSet();
          ResultSetMetaData rsmd = rs.getMetaData();

          out.println("<table>");
          while (rs.next()) {
            for (int i = 1; i <= rsmd.getColumnCount(); i++) {
              out.println("<tr><td width=\"26%\">" + rsmd.getColumnName(i) + "</td>");
              out.print("<td width=\"74%\"> <input type=\"text\" size=\"25\" value=\"");
              switch (rsmd.getColumnType(i)) {
                case Types.INTEGER: out.print(rs.getInt(i)); break;
                case Types.VARCHAR: out.print(rs.getString(i)); break;
                case Types.TIMESTAMP: out.print(rs.getTimestamp(i)); break;
                case Types.CHAR: out.print(rs.getString(i)); break;
                case Types.DATE: out.print(rs.getDate(i)); break;
                case Types.FLOAT: out.print(rs.getFloat(i)); break;
              }
              out.println("\"></td></tr>");
            }
          }
          rs.close();
          out.println("</table>");
        } else {
          out.println("<p>" + table + " has no record for Id =" + id + "</p>");
        }
        stmt.close();
      } catch (SQLException e) {
        out.println("<h1>ERROR:Mysql</h1> " + e.getMessage());
      }
    } else {
      out.println("<p>Error: the Table or Id Parameter is null</p>");
    }

    out.println(" </body>");
    out.println("</html>");
  }
}