

/**
 * Title:        dataQuery5
 * Description:  servlet to query data from  MySql datasource using JDOM
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author Randy George
 * @version 1.0
 */
  import java.io.*;
  import java.util.*;
  import java.sql.*;
  import java.net.*;

  import org.jdom.*;
  import org.jdom.JDOMException;
  import org.jdom.input.SAXBuilder;
  import org.jdom.output.XMLOutputter;

public class SvgChart5 {
  private Connection con = null;
  private String table;
  private String id;


  public SvgChart5(Connection con, String table, String id) {
    this.con = con;
    this.table = table;
    this.id = id;
  }

  public void write(PrintWriter out) {
    String sql = "";
    int total;

    if ((table!=null) && (id!=null)) {
      String template = "C:/Program Files/Apache Group/jakarta-tomcat/webapps/DataQuery5/svg/chart.svg";
      // setup DOM Parser with result set
      try {
        // create a SAX document builder using default Xerces without vailidation
        SAXBuilder builder = new SAXBuilder();
        // create the svg JDOM document from our chart.svg template
        Document svg = builder.build( new File(template));

        try {
          //collect a result set from our sql query
          Statement stmt = con.createStatement();
          sql = "SELECT * FROM " + table + " WHERE id=\"" + id + "\"";
          if (stmt.execute(sql)) {
            // There is a ResultSet
            ResultSet rs = stmt.getResultSet();
            // There is only one record
            while (rs.next()) {
              total = rs.getInt("total");
              Element root = svg.getRootElement();

              // change all the text elements
              Iterator it = root.getChildren("text").iterator();
              while (it.hasNext()) {
                Element obj = (Element)it.next();
                if (obj.getAttribute("id").getValue().equals("title")) {
                  obj.setText(table + " - tract: " + id);
                }
                else if (obj.getAttribute("id").getValue().equals("totalTxt")) {
                  obj.setText("Total: " + total);
                }
                else if (obj.getAttribute("id").getValue().equals("totalMaleTxt")) {
                  obj.setText("Total: " + rs.getInt("totalMale"));
                }
                 else if (obj.getAttribute("id").getValue().equals("totalFemaleTxt")) {
                  obj.setText("Total: " + rs.getInt("totalFemale"));
                }
              }
              // change all the rect elements
              it = root.getChildren("rect").iterator();
              while (it.hasNext()) {
                Element obj = (Element)it.next();
                if (obj.getAttribute("id").getValue().equals("under18")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("under18")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("adult")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("adult")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("over65")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("over65")*100.0/total));
                }

                if (obj.getAttribute("id").getValue().equals("under18Male")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("under18Male")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("adultMale")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("adultMale")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("over65Male")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("over65Male")*100.0/total));
                }

                if (obj.getAttribute("id").getValue().equals("under18Female")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("under18Female")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("adultFemale")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("adultFemale")*100.0/total));
                }
                else if (obj.getAttribute("id").getValue().equals("over65Female")) {
                  obj.setAttribute("height", Double.toString(rs.getInt("over65Female")*100.0/total));
                }
              }
            }
            rs.close();
          } else {
            out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">"+table + " has no record for Id =" + id+"</text>");
          }
          stmt.close();
        } catch (SQLException e) {
          out.println("<text style=\"&LABEL;\" x=\"25\" y=\"125\">ERROR:Mysql  " + e.getMessage()+"</text>");
        }

        // now that the changes are done output the doc to our servlet response
        XMLOutputter outputter = new XMLOutputter();
        outputter.output(svg, out);
      } catch (JDOMException e) {
        e.getMessage();
      } catch (Exception e) {
        e.getMessage();
      }
    }
  }
}
