

/**
 * Title:        ModifyDOM
 * Description:  DXF to SVG for Sams chapter 26
 * Copyright:    Copyright (c) 2002
 * Company:      MMC
 * @author
 * @version 1.0
 */

  import java.io.*;

public class Circle {
  private double x;
  private double y;
  private double r;
  private String layer = "";

  static int id = 0;

  public void readDXFCircle(BufferedReader in) throws IOException  {
    String line;
    while (((line = in.readLine()) != null)&&(!line.equals("  0"))) {
      if (line.equals("  8"))
        this.layer = in.readLine();
      else if (line.equals(" 10"))
        this.x= Double.parseDouble(in.readLine());
      else if (line.equals(" 20"))
        this.y= Double.parseDouble(in.readLine());
      else if (line.equals(" 40")) {
        this.r = Double.parseDouble(in.readLine());
        return;
      }
    }
  }

  public void writeSVGCircle(PrintWriter svg) throws IOException {
    svg.print("<circle cx='" + x + "' cy='" + (-y) + "' r='" + r + "'");
    if (DXFtoSVG.events) {
      svg.print(" id='CIR" + id++ + "' onmouseover='over(evt)' ");
      svg.print("onmouseout='out(evt)' onclick='click(evt)' ");
      svg.print("style='fill:yellow;fill-opacity:0.25'");
    }

    if (!layer.equals("")) svg.print(" fms:link='"+layer+"'");
    svg.println("/>");
  }
}