

/**
 * Title:        FMSGraph
 * Description:  Servlet to update graph points
 * Copyright:    Copyright (c) 2001
 * Company:      MMC
 * @author
 * @version 1.0
 */

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.io.*;

public class FMSGraph extends HttpServlet {

//Note: set this to the file path for your server
  private static final String FILE_PATH = "/home/httpd/html/svg-fms/svg/";

  private static final String CONTENT_TYPE = "text/html";
  private static double[] thermostat = {70.0, 70.0, 70.0, 70.0};

  /**Initialize global variables*/
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
  }

  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    //initialize variables
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    BufferedReader in = request.getReader();
    String cmd = request.getParameter("cmd");
    int zone = Integer.parseInt(request.getParameter("zone"));

    if (cmd != null) {
      if (cmd.equals("initialize")) {
        String line;
        response.setContentType("image/svg+xml");
        try {

          BufferedReader infile = new BufferedReader(new FileReader(FILE_PATH+"graph.svg"));
          while (((line = infile.readLine()) != null)) {
            if (line.indexOf("id=\"zone\"")!=-1) {
              StringBuffer temp = new StringBuffer("Zone <tspan id=\"zone\">");
              temp.append(zone);
              temp.append("</tspan>");
              line = temp.toString();
            }
            out.println(line);
          }
          infile.close();
        } catch (IOException e) {
          out.println("<text x=\"25\" y=\"125\">IO ERROR:Infile  " + e.getMessage()+"</text></svg>");
        }
      }
      else if (cmd.equals("set")) {
        try {
          thermostat[zone] = Integer.parseInt(in.readLine());
          out.println("new temp: " + thermostat[zone]);
        } catch (NumberFormatException e) {
          out.println("error");
        }
      }
      else if (cmd.equals("get")) {
        out.println(thermostat[zone]);
      }
      else {
        Random r1 = new Random();
        double d1 = (r1.nextGaussian()*5.0)+thermostat[zone] + 5.0;
        out.println(d1+";" + thermostat[zone]);
      }
    }
 }


  /**Process the HTTP Post request*/
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request,response);
  }

  /**Clean up resources*/
  public void destroy() {
  }
}