  var svgdoc;
  var svgroot;
  var zone;

// note: set this to the servlet path for your server
  var servlet_path = "/servlet/";

  var timer;
  var sample = 0;
  var sampleRate = 5000;//millisecond sampling rate
  var graphLen = 575; 
  var shift = 0.0;
  var dx = 75.0;

  var style;
  var active = false;
  var thermostat = 70;
  var tempLabel;

  // must be calculated from viewbox to w x h
  var x0 = 0;
  var y0 = 0;
  var vboxW = 0;
  var vboxH = 0;
  var svgW = 0;
  var svgH = 0;
  var sz = 0.25;


  function on_load(evt){
    svgdoc = evt.target.getOwnerDocument();
    svgroot = svgdoc.getDocumentElement();
    zone = svgdoc.getElementById("zone").firstChild.data;

    // slider intitialization
    slider = svgdoc.getElementById("slider");
    thumb = svgdoc.getElementById("thumb");
    tempLabel = svgdoc.getElementById("temp");

    //initialize cursor parameters
    var vbox = (svgroot.getAttribute("viewBox")).split(' ');
    x0 = parseFloat(vbox[0]);
    y0 = parseFloat(vbox[1]);
    vboxW = parseFloat(vbox[2]);
    vboxH = parseFloat(vbox[3]);
    svgW = parseFloat(svgroot.getAttribute("width"));
    svgH = parseFloat(svgroot.getAttribute("height"));


    // get initial thermostat temperature
    getURL(servlet_path+"FMSGraph?cmd=get&zone="+zone,tempGet);
  }

  // call back for initial thermostat setting
  function tempGet(status) {
    if (status.success) {
	thermostat = parseInt(status.content);
	svgdoc.getElementById("temp").firstChild.setData(thermostat);
      thumb.setAttribute("transform", "translate(" + (95-thermostat)+ " 0)");
    }
  }

  function dataUpdate() {
    getURL(servlet_path+"FMSGraph?cmd=data&zone="+zone,FmsBack);
    timer = setTimeout('dataUpdate()',sampleRate);
  }  

  function FmsBack(status){
    //alert("Success = " + status.success + " type: " + status.contentType);
    //alert(status.content);
    if (status.success) {
      var temp = status.content.split(';');
      // thermostat has changed update the thumb wheel
      if (temp[zone]!= thermostat.toString()) {
        thermostat = temp[zone];
        thumb.setAttribute("transform", "translate(" + (95-thermostat)+ " 0)");
        tempLabel.firstChild.setData(thermostat);
      }
      dx = dx + sampleRate*0.005;

      // when dx is greater than graphLen start scrolling graph paper
      if (dx>(graphLen-50)) {
        shift = shift - sampleRate * 0.005;
        var data = svgdoc.getElementById("DATA");
        data.setAttribute("transform","translate(" + shift + ",0)");
      }

      var data1 = svgdoc.getElementById("DATA1");
      
      dy = -50 - temp[0];
      attr = data1.firstChild.nextSibling.getAttribute("d");
      if (dx>graphLen) {
        attr = newPath(attr);
        obj = data1.firstChild.nextSibling.nextSibling;
        obj.parentNode.removeChild(obj);
        obj = data1.firstChild.nextSibling.nextSibling.nextSibling;
        obj.parentNode.removeChild(obj);
      }
      data1.firstChild.nextSibling.setAttribute("d",attr+"L"+dx+","+dy);
     
      var pt1 = svgdoc.createElement("circle");
      pt1.setAttribute("id", "d1"+sample);
      pt1.setAttribute("style", "stroke:red;stroke-width:0.01;fill:red;");
      pt1.setAttribute("cx", dx);
      pt1.setAttribute("cy", dy);
      pt1.setAttribute("r", 1);
      pt1.setAttribute("onmouseover", "over(evt)");
      pt1.setAttribute("onmouseout", "out(evt)");
      data1.appendChild(pt1);    

      var txtdata = svgdoc.createTextNode(temp[0].substring(0,6) + " degree F");
      var text = svgdoc.createElement("text");
      text.setAttribute("x", dx+2);
      text.setAttribute("y", dy);
      text.setAttribute("style", "stroke:black;stroke-width:0.01;fill:black;font-size:10;opacity:0");
      text.appendChild(txtdata);
      data1.appendChild(text);
      //alert(printNode(data1));

      sample++;
    }
  }

  function newPath(attr) {
    var p = attr.split('L');
    attr = "M"+p[1];
    for (var i = 2;i<p.length;i++) {
    attr = attr +"L"+p[i];
    }
    return attr;
  }

// ---------------------------------------------------
//  rollover effects for our newly created data points
// ---------------------------------------------------

  // mouse_over_a
  function over(evt) {
    var svgobj = evt.currentTarget;
    var svgstyle = svgobj.style;
    style = svgstyle.getPropertyValue('fill');
    svgstyle.setProperty ('fill','yellow');
    svgstyle = svgobj.nextSibling.style;
    svgstyle.setProperty ('opacity',1);
  }

  //mouse_out_b
  function out(evt) {
    var svgobj = evt.currentTarget;
    var svgstyle = svgobj.style;
    svgstyle.setProperty ('fill',style);
    svgstyle = svgobj.nextSibling.style;
    svgstyle.setProperty ('opacity',0);
  }

// ---------------------------------------------------
//      graph control buttons
// ---------------------------------------------------

  function Button_down(evt) {
    //toggle button down
    var button = evt.getCurrentTarget.id;
    var obj = evt.getCurrentTarget;
    obj = obj.firstChild.nextSibling.firstChild.nextSibling;
    obj.style.setProperty("fill","black");
    obj.nextSibling.nextSibling.style.setProperty("fill","white");
    if (button=="start") {
      Button_up("stop");
      dataUpdate();
    }
    else if (button=="stop") {
      Button_up("start");
      clearTimeout(timer);
    }
  }

  function Button_up(button) {
    //toggle button up
    var obj = svgdoc.getElementById(button);
    obj = obj.firstChild.nextSibling.firstChild.nextSibling;
    obj.style.setProperty("fill","white");
    obj.nextSibling.nextSibling.style.setProperty("fill","black");
  }

// -----------------------------------------------------------
//  note: Slider adapted from Dr Goesner http://www.mecxpert.de/svg/slider.html
//        and Kevin Lindsey http://www.kevlindev.com/gui/slider/index.htm
// -----------------------------------------------------------


  function SliderDown(evt) {
    active = true;
  }

  function SliderUp(evt) {
    active = false;
    postURL(servlet_path+"FMSGraph?cmd=set&zone="+zone,thermostat,TempSet,"text/plain",null);
  }

  function TempSet(status) {
  //alert(status.content);
  }

  function TempValue(evt){
    if (active){
      value = 144-((evt.clientY - svgroot.currentTranslate.y)*(vboxH/(svgH*svgroot.currentScale)));
      if (value>100) value = 100;
      if (value<0) value = 0;
      thumb.setAttribute("transform", "translate(" + (100-value)+ " 0)");
      thermostat = Math.round(value-5);
      tempLabel.firstChild.setData(thermostat);
    }
  }
